// 001 u
// 1 1 1

(*$r+*)

unit u_net_dbx_create_table;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DBXpress, FMTBcd, Borland.Vcl.Db, Borland.Vcl.SqlExpr,
  Borland.Vcl.StdCtrls, System.ComponentModel;

type
  TForm2 = class(TForm)
    Memo1: TMemo;
    create_table_: TButton;
    SQLConnection1: TSQLConnection;
    drop_table_: TButton;
    fill_table_: TButton;
    SQLQuery1: TSQLQuery;
    open_table_: TButton;
    insert_one_: TButton;
    procedure create_table_Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure drop_table_Click(Sender: TObject);
    procedure fill_table_Click(Sender: TObject);
    procedure open_table_Click(Sender: TObject);
    procedure insert_one_Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

    implementation
      uses u_c_net_display, u_c_net_log;

   
    {$R *.nfm}

    const k_table_name= 'formations_4';

    procedure TForm2.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;
      end; // FormCreate

    procedure TForm2.create_table_Click(Sender: TObject);
      begin
        with SqlQuery1 do
        begin
          Close;

          with Sql do
          begin
            Clear;
            Add('CREATE TABLE '+ k_table_name);
            Add('  ('
                +'    f_numero INTEGER,');
            Add('     f_nom CHAR(28),');
            Add('     f_jours SMALLINT,');
            Add('     f_prix NUMERIC(5, 2)');
            Add('   )');
          end; // with Sql

          display_strings(Sql);

          Try
            SqlConnection1.Open;

            display('Exec');

            ExecSql;

            display('  ok');
          except
            on e: Exception do
              display('  *** pb_create '+ e.Message);
          end;
        end; // with SqlQuery1
      end; // create_table_Click

    procedure execute_sql_request(p_sql_request: String);
      begin
        with Form2, SqlQuery1 do
        begin
          Close;

          with Sql do
          begin
            Clear;
            Add(p_sql_request);
          end; // with Sql

          display_strings(Sql);

          Try
            SqlConnection1.Open;

            ExecSql;

            display('  ok');
          except
            on e: Exception do
              display('  *** pb_create '+ e.Message);
          end;
        end; // with SqlQuery1
      end; // execute_sql_request

    procedure TForm2.open_table_Click(Sender: TObject);
      begin
        execute_sql_request('SELECT * FROM '+ k_table_name);
      end; // open_table_Click

    procedure TForm2.drop_table_Click(Sender: TObject);
      begin
        execute_sql_request('DROP TABLE '+ k_table_name);
      end; // drop_table_Click

    procedure TForm2.insert_one_Click(Sender: TObject);
      begin
        execute_sql_request(
                 'INSERT INTO '+ k_table_name
               + ' (f_numero, f_nom, f_jours, f_prix)'
               + ' VALUES (1, '+ QuotedStr('Asp et Delphi')+ ', 3, 1400.40)')
      end; // insert_one_Click

    procedure TForm2.fill_table_Click(Sender: TObject);
        // -- insert several hard coded values in a row

      procedure insert_generic(p_number: Integer; p_name: String; p_days: Integer; p_cost: Double);
        begin
          DecimalSeparator:= '.';
          execute_sql_request(
                   'INSERT INTO '+ k_table_name
                 + ' (f_numero, f_nom, f_jours, f_prix)'
                 + ' VALUES ('
                 +     IntToStr(p_number)+ ', '+ QuotedStr(p_name)
                 + ', '+ IntToStr(p_days)+ ', '+ FloatToStr(p_cost)+ ')');
          DecimalSeparator:= ',';
        end; // insert_generic

      begin // fill_table_Click
        insert_generic(2, 'Initiation Delphi', 3, 1400);
        insert_generic(3, 'Bases de Donnes Delphi', 3, 1400);
        insert_generic(4, 'Interbase Delphi', 3, 1400);
        insert_generic(5, 'Composants Delphi', 3, 1400);
        insert_generic(6, 'UML et Patterns en Delphi', 3, 1400);
        insert_generic(7, 'Delphi Web Services', 3, 1400);
      end; // fill_table_Click

end.
